import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
var _jsxFileName = "C:\\Dev\\20_gsoft\\sg-orbit\\packages\\react-components\\components\\date-range-picker\\src\\date-range-picker-input.jsx";
import _JSXStyle from "styled-jsx/style";
import React from "react";
import { Button, Ref } from "semantic-ui-react";
import { PureComponent, cloneElement, createRef } from "react";
import { bool, func, node, object, string } from "prop-types";
import { isNil } from "lodash";
import cx from "classnames";
export class DateRangePickerInput extends PureComponent {
  constructor() {
    super(...arguments);

    _defineProperty(this, "_clearButtonRef", createRef());

    _defineProperty(this, "handleClick", event => {
      const {
        onClick
      } = this.props;

      if (!this._clearButtonRef.current.contains(event.target)) {
        onClick(event, this.props);
      }
    });

    _defineProperty(this, "handleClear", event => {
      const {
        onClear
      } = this.props;
      onClear(event, this.props);
    });
  }

  getValue() {
    const {
      startDate,
      endDate,
      placeholder,
      rangeFormat,
      dateFormat
    } = this.props;

    const result = (text, isPlaceholder) => ({
      text,
      isPlaceholder
    });

    if (!isNil(startDate)) {
      if (!isNil(endDate)) {
        return result(rangeFormat.replace("{startDate}", startDate.format(dateFormat)).replace("{endDate}", endDate.format(dateFormat)), false);
      }

      return result(startDate.format(dateFormat));
    }

    return result(placeholder, true);
  }

  getCssClasses(value) {
    const {
      disabled,
      open,
      className
    } = this.props;
    const openedClasses = open && !disabled ? " b--marine-700 marine-700" : " b--cloud-500 marine-200";
    const disabledClasses = cx({
      " bg-cloud-100 cloud-400 crsr-not-allowed": disabled
    });
    const placeholderClasses = cx({
      " marine-700": !value.isPlaceholder && !disabled
    });
    const defaultClasses = "input pv3 ph4 ba outline-0 f6 h9 br2 flex items-center".concat(openedClasses).concat(placeholderClasses).concat(disabledClasses);
    return isNil(className) ? defaultClasses : "".concat(defaultClasses, " ").concat(className);
  }

  renderIcon() {
    const {
      icon
    } = this.props;
    const {
      disabled
    } = this.props;
    return cloneElement(icon, {
      className: "w6 h6 ".concat(disabled ? " fill-cloud-500" : " fill-marine-700", " mr4")
    });
  }

  renderClearButton(value) {
    const {
      clearIcon,
      disabled,
      open
    } = this.props;
    return React.createElement("div", {
      className: cx({
        dn: value.isPlaceholder || disabled || open
      }),
      __source: {
        fileName: _jsxFileName,
        lineNumber: 81
      },
      __self: this
    }, React.createElement(Ref, {
      innerRef: this._clearButtonRef,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 82
      },
      __self: this
    }, React.createElement(Button, {
      circular: true,
      size: "mini",
      primary: true,
      icon: true,
      className: "transparent",
      onClick: this.handleClear,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 83
      },
      __self: this
    }, clearIcon)));
  }

  render() {
    const {
      onKeyDown,
      disabled
    } = this.props;
    const value = this.getValue();
    return React.createElement("div", {
      onClick: this.handleClick,
      onKeyDown: onKeyDown,
      tabIndex: disabled ? null : "0",
      autoComplete: "off",
      disabled: disabled,
      className: "jsx-2462695752" + " " + (this.getCssClasses(value) || ""),
      __source: {
        fileName: _jsxFileName,
        lineNumber: 96
      },
      __self: this
    }, this.renderIcon(), React.createElement("span", {
      className: "jsx-2462695752" + " " + "flex-grow-1",
      __source: {
        fileName: _jsxFileName,
        lineNumber: 105
      },
      __self: this
    }, value.text), this.renderClearButton(value), React.createElement(_JSXStyle, {
      id: "2462695752",
      __self: this
    }, ".input.jsx-2462695752:not(\"disabled\"){cursor:text;}.input.jsx-2462695752:focus{border:1px solid var(--marine-700);color:var(--marine-700);}"));
  }

}