import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
var _jsxFileName = "C:\\Dev\\20_gsoft\\sg-orbit\\packages\\react-components\\components\\date-range-picker\\src\\date-range-picker-presets.jsx";
import _JSXStyle from "styled-jsx/style";
import React from "react";
import { PRESET_SHAPE } from "./presets";
import { PureComponent } from "react";
import { arrayOf, bool, func, node, object, shape, string } from "prop-types";
import { isNil } from "lodash";
import { isSameDay } from "./utils";
import cx from "classnames";

class Preset extends PureComponent {
  constructor() {
    super(...arguments);

    _defineProperty(this, "handleClick", event => {
      const {
        preset,
        onSelectPreset
      } = this.props;
      onSelectPreset(event, preset, this.props);
    });
  }

  render() {
    const {
      preset,
      isSelected,
      isBlocked
    } = this.props;
    return React.createElement("li", {
      className: "jsx-3176124805" + " " + "pa2 mb2 lh-solid",
      __source: {
        fileName: _jsxFileName,
        lineNumber: 26
      },
      __self: this
    }, isBlocked ? React.createElement("span", {
      className: "jsx-3176124805" + " " + "f7 cloud-400 outline-0",
      __source: {
        fileName: _jsxFileName,
        lineNumber: 29
      },
      __self: this
    }, preset.text) : React.createElement("button", {
      type: "button",
      onClick: this.handleClick,
      className: "jsx-3176124805" + " " + (cx("f7 marine-700 outline-0 pointer hover-primary-500", {
        "primary-500": isSelected
      }) || ""),
      __source: {
        fileName: _jsxFileName,
        lineNumber: 32
      },
      __self: this
    }, preset.text), React.createElement(_JSXStyle, {
      id: "3176124805",
      __self: this
    }, "button.jsx-3176124805{background-color:transparent;border:none;padding:0;}"));
  }

}

export class DateRangePickerPresets extends PureComponent {
  constructor() {
    super(...arguments);

    _defineProperty(this, "isDayBlocked", day => {
      const {
        minDate,
        maxDate
      } = this.props;

      if (!isNil(minDate) && !isNil(maxDate)) {
        return day.isBefore(minDate, "day") || day.isAfter(maxDate, "day");
      }

      if (!isNil(minDate)) {
        return day.isBefore(minDate, "day");
      }

      if (!isNil(maxDate)) {
        return day.isAfter(maxDate, "day");
      }

      return false;
    });
  }

  isPresetBlocked(preset) {
    const {
      minDate,
      maxDate
    } = this.props;

    if (!isNil(minDate) || !isNil(maxDate)) {
      return this.isDayBlocked(preset.startDate) || this.isDayBlocked(preset.endDate);
    }

    return false;
  }

  isPresetSelected(preset) {
    const {
      startDate,
      endDate
    } = this.props;
    return isSameDay(preset.startDate, startDate) && isSameDay(preset.endDate, endDate);
  }

  renderPresets() {
    const {
      onSelectPreset,
      presets
    } = this.props;
    return presets.map(x => {
      const isSelected = this.isPresetSelected(x);
      const isBlocked = this.isPresetBlocked(x);
      return React.createElement(Preset, {
        key: x.text,
        preset: x,
        onSelectPreset: onSelectPreset,
        isSelected: isSelected,
        isBlocked: isBlocked,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 110
        },
        __self: this
      });
    });
  }

  render() {
    const {
      presets,
      icon,
      className
    } = this.props;
    const defaultClasses = "presets flex flex-column pt8 ph8 br b--cloud-100";
    const classes = isNil(className) ? defaultClasses : "".concat(defaultClasses, " ").concat(className);

    if (presets.length > 0) {
      return React.createElement("div", {
        className: "jsx-896343753" + " " + (classes || ""),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 122
        },
        __self: this
      }, React.createElement("div", {
        className: "jsx-896343753" + " " + "self-center mb8",
        __source: {
          fileName: _jsxFileName,
          lineNumber: 123
        },
        __self: this
      }, icon), React.createElement("ul", {
        className: "jsx-896343753",
        __source: {
          fileName: _jsxFileName,
          lineNumber: 124
        },
        __self: this
      }, this.renderPresets()), React.createElement(_JSXStyle, {
        id: "896343753",
        __self: this
      }, "ul.jsx-896343753{padding:0;margin:0;list-style-type:none;}.presets.jsx-896343753{min-width:200px;}"));
    }

    return null;
  }

}