import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
var _jsxFileName = "C:\\Dev\\20_gsoft\\sg-orbit\\packages\\react-components\\components\\popup\\src\\popup.jsx";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React from "react";
import { KEYS } from "@orbit-ui/react-components-shared";
import { PureComponent, createRef } from "react";
import { any, bool, func, string } from "prop-types";
import { isNil } from "lodash";
export class Popup extends PureComponent {
  constructor() {
    super(...arguments);

    _defineProperty(this, "_containerRef", createRef());

    _defineProperty(this, "handleOutsideClick", event => {
      const {
        onOutsideClick
      } = this.props;

      if (!this._containerRef.current.contains(event.target)) {
        if (!isNil(onOutsideClick)) {
          onOutsideClick(event, this.props);
        }
      }
    });

    _defineProperty(this, "handleKeyDown", event => {
      const {
        onEscapeKeyDown
      } = this.props;

      if (event.keyCode === KEYS.esc) {
        if (!isNil(onEscapeKeyDown)) {
          onEscapeKeyDown(event, this.props);
        }
      }
    });
  }

  componentDidUpdate(prevProps) {
    const {
      visible
    } = this.props;

    if (visible !== prevProps.visible) {
      if (visible) {
        this.bindEvents();
      } else {
        this.unbindEvents();
      }
    }
  }

  componentWillUnmount() {
    this.unbindEvents();
  }

  getPositioningStyle() {
    const {
      top,
      bottom,
      left,
      right
    } = this.props;
    const positions = {};

    if (!isNil(top)) {
      positions.top = top;
    }

    if (!isNil(bottom)) {
      positions.bottom = bottom;
    }

    if (!isNil(left)) {
      positions.left = left;
    }

    if (!isNil(right)) {
      positions.right = right;
    }

    return positions;
  }

  bindEvents() {
    document.addEventListener("click", this.handleOutsideClick, false);
    document.addEventListener("keydown", this.handleKeyDown, false);
  }

  unbindEvents() {
    document.removeEventListener("click", this.handleOutsideClick, false);
    document.removeEventListener("keydown", this.handleKeyDown, false);
  }

  render() {
    const {
      visible,
      children
    } = this.props;

    if (!visible) {
      return null;
    }

    return React.createElement("div", {
      style: _objectSpread({
        position: "absolute",
        zIndex: 10
      }, this.getPositioningStyle()),
      ref: this._containerRef,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 98
      },
      __self: this
    }, children);
  }

}